<?php


namespace Schaffen\ServiceOrder\ServiceOrder\Models;


use Illuminate\Database\Eloquent\Model;
use Schaffen\ServiceOrder\ServiceOrder\Traits\HasServiceOrder;

class ServiceOrderExecution extends Model
{

   use HasServiceOrder;

   protected $table = "os.os_execucao";
   protected $primaryKey = "ose_codigo";
   protected $prefix = "ose";
   protected $fillable = [
      "ose_data_inicial",
      "ose_data_final",
      "ose_km_inicial",
      "ose_km_final"
   ];

   const CREATED_AT = "ose_date_insert";
   const CREATED_BY = "ose_user_insert";
   const UPDATED_AT = "ose_date_update";
   const UPDATED_BY = "ose_user_update";


}
