<?php

namespace Schaffen\ServiceOrder\ServiceOrder\Models;


use Illuminate\Database\Eloquent\Model;
use Schaffen\Core\Product\Traits\HasProduct;
use Schaffen\ServiceOrder\ServiceOrder\Traits\HasServiceOrder;

class ServiceOrderItem extends Model
{
   use HasProduct, HasServiceOrder;

   const CREATED_AT = "osps_date_insert";
   const CREATED_BY = "osps_user_insert";
   const UPDATED_AT = "osps_date_update";
   const UPDATED_BY = "osps_user_update";
   public $prefix = 'osps';
   protected $connection = 'dynamicdb';
   protected $table = "os.os_produtos_servicos";
   protected $primaryKey = "osps_codigo";
   protected $fillable = ["osps_fk_os_codigo", "osps_quantidade", "osps_valor_unitario", "osps_servico",
      "osps_recursos", "osps_fk_pve_codigo", "osps_serial", "osps_fk_cfop_codigo",
      "osps_ref_cliente", "osps_prazo_entegra", "osps_numero_sequencia",
      "osps_fk_agc_codigo", "osps_tipo_produto", "osps_desconto", "osps_desconto_porcentagem", "osps_agc_seq"];
   protected $casts = [
      "osps_recursos" => "json"
   ];

}
