<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderExecutionRepository;
use Schaffen\ServiceOrder\ServiceOrder\Traits\SetServiceOrderOnAssociate;

class CreateOrUpdateServiceOrderExecution
{

   use SetServiceOrderOnAssociate;

   /**
    * @var ServiceOrderExecutionRepository
    */
   private ServiceOrderExecutionRepository $service_order_execution_repository;

   public function __construct(
      ServiceOrderExecutionRepository $service_order_execution_repository
   )
   {
      $this->service_order_execution_repository = $service_order_execution_repository;
   }

   public function handleExecutions(
      $executions,
      $service_order_id
   )
   {
      $executions = !is_array($executions) ? [$executions] : $executions;
      $return = [];
      foreach ($executions as $execution) {
         $execution['service_order_id'] = $service_order_id;
         $return[] = $this->service_order_execution_repository->storeOrUpdate($execution, $execution['ose_codigo'] ?? null,
            $this->getServiceOrderRelation($service_order_id)
         );

      }
      return $return;
   }
}
