<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderItemRepository;
use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderItemResourcesRepository;

class CreateOrUpdateServiceOrderItemResources
{

   /**
    * @var ServiceOrderItemRepository
    */
   private $service_order_item_resources_repository;
   /**
    * @var ServiceOrderItemRepository
    */
   private ServiceOrderItemRepository $order_item_repository;

   public function __construct(
      ServiceOrderItemResourcesRepository $service_order_item_resources_repository,
      ServiceOrderItemRepository $order_item_repository
   )
   {

      $this->service_order_item_resources_repository = $service_order_item_resources_repository;
      $this->order_item_repository = $order_item_repository;
   }

   public function handleResources(
      array $resources_service_order, $resources_item, $item_id, $product_service = 0
   )
   {

      $return = [];
      $osps_recursos = [];
      foreach ($resources_item as $key => $resource_item) {
         foreach ($resources_service_order as $resource_service_order) {
            $item_resource = $resource_item['pes_codigo'] ?? $resource_item;
            if ($resource_service_order['pes_codigo'] != $item_resource) {
               continue;
            }
            $osps_recursos[] = ["pes_codigo" => $item_resource];

            $comission = $product_service == 1 ?
               $resource_service_order["comissao_servico"] ?? 0 :
               $resource_service_order["comissao_produto"] ?? 0;
            $input = array(
               'ospsr_fk_vendedor_codigo' => $item_resource,
               'ospsr_fk_osps_codigo' => $item_id,
               'ospsr_porcentagem_comissao' => $comission,
            );
            $return[] = $this->service_order_item_resources_repository->storeOrUpdate($input);

         }
      }
      if (!empty($return)) {
         $this->order_item_repository->storeOrUpdate(['osps_recursos' => $osps_recursos], $item_id);
      }
      return $return;
   }
}
