<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderItemRepository;

class CreateOrUpdateServiceOrderItemTaxes
{

   /**
    * @var ServiceOrderItemRepository
    */
   private $service_order_item_taxes_repository;

   public function __construct(ServiceOrderItemRepository $service_order_item_taxes_repository)
   {

      $this->service_order_item_taxes_repository = $service_order_item_taxes_repository;
   }

   public function handleTaxes(
      $item_taxes
   )
   {

      if (!empty($os_impostos)){

         $dadosOspsImpostos = array(
            'ospsi_codigo' => !empty($os_impostos['ospsi_codigo']) ? $os_impostos['ospsi_codigo'] : null,
            'ospsi_fk_osps_codigo' => $item->osps_codigo,
            'ospsi_sn_aliquota' => $os_impostos['ospsi_sn_aliquota'],
            'ospsi_sn_valor' => $os_impostos['ospsi_sn_valor'],
            'ospsi_st_aliquota' => $os_impostos['ospsi_st_aliquota'],
            'ospsi_st_valor' => $os_impostos['ospsi_st_valor'],
            'ospsi_aprov_icms_aliquota' => $os_impostos['ospsi_aprov_icms_aliquota'],
            'ospsi_aprov_icms_valor' => $os_impostos['ospsi_aprov_icms_valor']
         );

         if(!empty($dadosOspsImpostos['ospsi_codigo'])){
            $ospsImposto = OspsImpostos::find($dadosOspsImpostos['ospsi_codigo']);
            $ospsImposto->fill($dadosOspsImpostos);
            $ospsImposto->save();
         }else {
            $ospsImposto = new OspsImpostos($dadosOspsImpostos);
            $ospsImposto->save();
         }
      }

      return $this->service_order_item_taxes_repository->storeOrUpdate($item_taxes, $item_taxes['ospsi_codigo']);
   }
}
