<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


use Schaffen\Core\Person\Repositories\PersonRepository;
use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderRepository;
use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderResourceRepository;
use Schaffen\ServiceOrder\ServiceOrder\Traits\SetServiceOrderOnAssociate;

class CreateOrUpdateServiceOrderResource
{

   use SetServiceOrderOnAssociate;

   /**
    * @var ServiceOrderResourceRepository
    */
   private ServiceOrderResourceRepository $service_order_resource_repository;
   /**
    * @var PersonRepository
    */
   private PersonRepository $person_repository;
   /**
    * @var ServiceOrderRepository
    */
   private ServiceOrderRepository $service_order_repository;

   public function __construct(
      ServiceOrderResourceRepository $service_order_resource_repository,
      PersonRepository $person_repository
   )
   {

      $this->service_order_resource_repository = $service_order_resource_repository;
      $this->person_repository = $person_repository;
   }

   public function handleResources(
      $resources, $service_order_id
   )
   {
      $resources = !is_array($resources) ? [$resources] : $resources;
      $return = [];

      foreach ($resources as $resource) {
         $return[] = $this->service_order_resource_repository->storeOrUpdate(
            $resource, $resource['osr_codigo'] ?? null,
            $this->getServiceOrderRelation($service_order_id)
         );

      }
      return $return;
   }
}
