<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


class DisableServiceOrder
{
   public function inativarOs($id)
   {
      try {
         DB::beginTransaction();

         $os = Os::find($id);
         $os->os_fk_sto_codigo = -2;
         $os->save();

         //registra o log
         $tipoOcorrencia = new OsLog([
            "osl_fk_os_codigo" => $os->os_codigo,
            "osl_fk_too_codigo" => TipoOcorrenciaOs::REMOVIDA,
            "osl_ocorrencia" => $os->os_tipo == Os::TIPO_ORCAMENTO ?
               "Orçamento removido." :
               "Ordem de serviço removida.",
            "osl_codigo_operacao" => $os->os_codigo
         ]);
         $tipoOcorrencia->save();

         DB::commit();

         return Response::success('Os removida com sucesso.', $os);
      } catch (SCHException $e) {
         DB::rollback();
         return Response::faillure($e->getMessage(), $e);
      } catch (\Exception $e) {
         DB::rollback();
         return Response::error($e->getMessage(), $e);
      }
   }
}
