<?php

namespace Schaffen\ServiceOrder;

use Illuminate\Database\Eloquent\Relations\Relation;
use Illuminate\Support\ServiceProvider;

class ServiceOrderServiceProvider extends ServiceProvider
{
   public function boot()
   {

      $morph_map = Relation::morphMap();
      Relation::morphMap(array_merge($morph_map, [
         'service-order' => 'Schaffen\ServiceOrder\ServiceOrder\Models\ServiceOrder',
      ]));

   }


   public function register()
   {
      $this->registerServiceOrder();
   }

   private function registerServiceOrder()
   {
      $this->app->bind('service-order', function ($app) {
         return new ServiceOrder($app);
      });
   }

}
